# Príloha A -- implementácia

Táto príloha obsahuje zdrojové kódy, ktoré sme v našej práci vytvorili a sú potrebné
na zreprodukovanie našich výsledkov. Tieto programy sú však iba prototyp, nie hotový
softvérový balík, ich spojazdnenie teda nie je úplne triviálne. 

## Kompilácia

Väčšina kódu je napísaná v jazyku Python 3, teda ju netreba kompilovať. Niektoré časti
sú však v C++, tie je potrebné skompilovať a vytvoriť z nich knižnicu.
Všetok kód v C++ je v jednom súbore `reresquiggle.cpp`.

```
g++ -c -fPIC reresquiggle.cpp -o reresquiggle.o --std=c++11
g++ -shared -Wl,-soname,reresquiggle.so -o reresquiggle.so reresquiggle.o
```

## Závislosti

Na zreprodukovanie našich výsledkov je potrebných niekoľko existujúcich nástrojov:

* Ľubovoľný prekladač báz
* Balíček [tombo](https://github.com/nanoporetech/tombo) s jeho závislosťami
* Ak chcete spúšťať aj priamočiary prístup z kapitoly 4.3.5, tak je potrebné
  mať nainštalovaný aj balíček [bwapy](https://github.com/nanoporetech/bwapy).


## Identifikácia SNPov

Na identifikáciu SNPov v čítaniach treba v týchto čítaniach najprv určiť bázy pomocou prekladača báz.
Následne treba na všetkých čítaniach spustiť nástroj `resquiggle` z balíčka tombo.
Dokumentácia k balíčku tombo je na <https://nanoporetech.github.io/tombo/>.

Po tom, čo na čítaniach úspešne zbehol nástroj `resquiggle`, na nich stačí spustiť program 
`detect_SNP.py`.

## Väčšie experimenty

Na spúšťanie experimentov v našej práci sme používali skripty
`prepare_dataset.sh` (ktorý volá `make_SNPs.py`), `run_with_configuration.sh` a `evaluate.py`.
Tieto skripty nebudú fungovať, ak nemáte všetky nástroje nainštalované na miestach, kde ich očakávajú.